--
-- Mod: Animals Keeper GUI
--
-- @Author D3r1L
-- @Date 22.08.2019
-- @Version 1.0 ..... Change animalsKeeper settings menu
-- Copyright (C) D3r1L, All Rights Reserved.
--

awGui = {};

local awGui_mt = Class(awGui, ScreenElement)

local moneyCurrency = " $"
if g_gameSettings.moneyUnit == 1 then
	moneyCurrency = " €" 
elseif g_gameSettings.moneyUnit == 2 then
	moneyCurrency = " $"
elseif g_gameSettings.moneyUnit == 3 then
	moneyCurrency = " £"
end;
	
function awGui:new(target, custom_mt)
    local self = ScreenElement:new(target, awGui_mt)
    self.returnScreenName = ""
    return self
end;

function awGui:onOpen()
    awGui:superClass().onOpen(self)
	FocusManager:setFocus(self.backButton)
	-- print("Animals Keeper: GUI Opened")
end;

function awGui:onClose()
    awGui:superClass().onClose(self)
	-- print("Animals Keeper: GUI Closed")
end;

function awGui:onClickBack()
    awGui:superClass().onClickBack(self)
	animalsKeeper:updateGui()
	-- print("Animals Keeper: Loading GUI settings and saving (menu exit)")
end;

function awGui:onClickOk()
    awGui:superClass().onClickOk(self)
	animalsKeeper:settingsFromGui(
		--self.awStraw:getIsChecked(),
		self.awStrawStable:getState(),
		self.awStrawCost:getState(),
		self.awWaterCost:getState(),
		self.awWater:getIsChecked(),
		self.awPens:getIsChecked(),
		self.awPensCost:getState(),
		self.awSpeed:getState()
	)
    self:onClickBack()
	print("Animals Keeper: Updating settings from GUI menu...")
end

function awGui:onIngameMenuHelpTextChanged(element)
end

function awGui:onCreateAwGuiHeader(element)
	element.text = g_i18n:getText('gui_aw_Setting')
	print("Animals Keeper: Creating GUI elements...")
end

--function awGui:onCreateSetLitterStraw(element)
--	self.awStraw = element
--	element.labelElement.text = g_i18n:getText("gui_ak_Straw")
--	element.toolTipText = g_i18n:getText("gui_ak_StrawInfo")
--end

function awGui:onCreateSetLitterStrawStable(element)
	self.awStrawStable = element
	element.labelElement.text = g_i18n:getText("gui_ak_Straw")
	element.toolTipText = g_i18n:getText("gui_ak_StrawInfo")
	local wStable = {}
	for i = 1, #animalsKeeper.stables, 1 do
		if i == 1 then
			wStable[i] = g_i18n:getText("input_Straw_Off") -- "Off" -- .. tostring(animalsKeeper.stables[i])
		elseif i == 2 then
			wStable[i] = g_i18n:getText("input_Straw_On") -- "On" -- .. tostring(animalsKeeper.stables[i])
		elseif i == 3 then
			wStable[i] = g_i18n:getText("input_Straw_NoCows") -- "no cows" -- .. tostring(animalsKeeper.stables[i])
		elseif i == 4 then
			wStable[i] = g_i18n:getText("input_Straw_NoPigs") -- "no pigs" -- .. tostring(animalsKeeper.stables[i])
		elseif i == 5 then
			wStable[i] = g_i18n:getText("input_Straw_NoHorses") -- "no horses" -- .. tostring(animalsKeeper.stables[i])
		end
	end
	element:setTexts(wStable)
end

function awGui:onCreateSetStrawCost(element)
	self.awStrawCost = element
	element.labelElement.text = g_i18n:getText("gui_aw_Fee")
	element.toolTipText = g_i18n:getText("gui_aw_FeeInfo")
	local wfee = {}
	for i = 1, #animalsKeeper.costs, 1 do
		wfee[i] = "" .. tostring(animalsKeeper.costs[i]) .. moneyCurrency
	end
	element:setTexts(wfee)
end

function awGui:onCreateSetFillCapacity(element)
	self.awWater = element
	element.labelElement.text = g_i18n:getText("gui_aw_FillCapacity")
	element.toolTipText = g_i18n:getText("gui_aw_FillCapacityInfo")
end

function awGui:onCreateSetWorkerCost(element)
	self.awWaterCost = element
	element.labelElement.text = g_i18n:getText("gui_aw_CostPerAnimal")
	element.toolTipText = g_i18n:getText("gui_aw_CostPerAnimalInfo")
	local wcost = {}
	for i = 1, #animalsKeeper.costs, 1 do
		wcost[i] = "" .. tostring(animalsKeeper.costs[i]) .. moneyCurrency
	end
	element:setTexts(wcost)
end

function awGui:onCreateSetCleanPens(element)
	self.awPens = element
	element.labelElement.text = g_i18n:getText("gui_aw_CleanPens")
	element.toolTipText = g_i18n:getText("gui_aw_CleanPensInfo")
end

function awGui:onCreateSetHorseRate(element)
	self.awPensCost = element
	element.labelElement.text = g_i18n:getText("gui_aw_HorseRate")
	element.toolTipText = g_i18n:getText("gui_aw_HorseRateInfo")
	local wrate = {}
	for i = 1, #animalsKeeper.costs, 1 do
		wrate[i] = "" .. tostring(animalsKeeper.costs[i]) .. moneyCurrency
	end
	element:setTexts(wrate)
end

function awGui:onCreateSetSpeedPlayer(element)
	self.awSpeed = element
	element.labelElement.text = g_i18n:getText("gui_aw_SpeedPlayer")
	element.toolTipText = g_i18n:getText("gui_aw_SpeedPlayerInfo")
	local wSpeed = {}
	for i = 1, #animalsKeeper.speed, 1 do
		if i == 1 then
			wSpeed[i] = "Normal"
		elseif i == 2 then
			wSpeed[i] = "Speed x2"
		elseif i == 3 then
			wSpeed[i] = "Speed x4"
		elseif i == 4 then
			wSpeed[i] = "Speed x6"
		elseif i == 5 then
			wSpeed[i] = "Speed x8"
		end
	end
	element:setTexts(wSpeed)
end

--function awGui:setStraw(state)
--	self.awStraw:setIsChecked(state)
--end

function awGui:setStrawStable(indexStable)
	self.awStrawStable:setState(indexStable, 1)
end

function awGui:setStrawCost(indexFee)
	self.awStrawCost:setState(indexFee, false)
end

function awGui:setWater(state)
	self.awWater:setIsChecked(state)
end

function awGui:setWaterCost(indexCost)
	self.awWaterCost:setState(indexCost, false)
end

function awGui:setCleanPens(state)
	self.awPens:setIsChecked(state)
end

function awGui:setCleanPensCost(indexRate)
	self.awPensCost:setState(indexRate, false)
end

function awGui:setSpeedPlayer(indexSpeed)
	self.awSpeed:setState(indexSpeed, 1)
end